<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Events3 extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		error_reporting(0);
		parent::__construct();
					
		////error_reporting(E_ALL & ~E_NOTICE & ~E_DEPRECATED & ~E_STRICT & ~E_USER_NOTICE & ~E_USER_DEPRECATED);
		
		$var_userid = $this->session->userdata('userid');
		$var_qr_public = $this->session->userdata('qr_public'); // #### with QR they are logged into the company USER not needed 

		$this->load->model('Asys_multi8');
		
		// ################################################################
		// #### CORRECT SETTING TO SWITCH PUBLIC MODE - ONLY COMP IS SET 
		$var_compid = $this->session->userdata('compid');
		if ($var_compid != "" and $_POST['sess_compid'] == "") {
			$_POST['sess_compid'] = $var_compid;
		}
		
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE 
		// ################################################################ 
		
		$this->load->model('Recheck_access6');
		$var_access_status = $this->Recheck_access6->reset_access6();
		if ($var_access_status == "expired/logout") {
			// #### The userid and/or compid expired or logged out - go to bible app as a public module 
			redirect('bible3/bible_display', 'refresh');
		}

		$this->load->model('System_modules');

		// ################################################################
		// #### CORRECT SETTING TO SWITCH PUBLIC MODE OR FULL MODULE ACCESS
		// ################################################################
		
		$this->load->helper('html');
		$this->load->model('Load_sys_data'); //### FOR MENUS AND TABS 
		////$this->load->model('mArtist');
		$this->load->helper('text');
		$this->load->library('cart');
		
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{		
		error_reporting(0);
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}	

	public function check_function()
	{
		error_reporting(0);
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		if ($callfunction == "details") {
			$this->details('index');
		} else {
		}
	}	
	
	public function clear_sess_data_array($this_data_rec)
	{
		// ############################################################################################
		// #### MAKE THIS A GLOBAL MODEL ONCE TESTED TO INTERROGATE THE DATA - AND HANDLE CRASHES  ####
		// ############################################################################################
		
		foreach($this_data_rec as $key => $value) {
			if (strpos($key,'sess_') !== false) {
				unset($this_data_rec[$key]);
			}
		}
		return($this_data_rec);
	}

	public function follow_up_edit()
	{

		error_reporting(0);
		$varcompid = $_POST['sess_compid'];
		
		if ($_POST['follup_contact_type'] != "")  {
			$data_rec = array();
			$data_rec = $_POST;
			$date_array = explode('/',$_POST['follup_contact_date_time']);
			$var_follup_contact_date_sort = $date_array[2] . "/" . $date_array[1] . "/" . $date_array[0];
			$data_rec['follup_contact_date_sort'] = $var_follup_contact_date_sort;
			
			unset($data_rec['userid']); unset($data_rec['compid']); 
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);
						
			//// // // // var_dump($data_rec);
			
			if ($_POST['id'] != 0) {
				$data_rec = $this->clear_sess_data_array($data_rec);
				$this->db->where('id', $_POST['id']);
				$this->db->update('teampro_follow_ups', $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$data_rec = $this->clear_sess_data_array($data_rec);
				$this->db->insert('teampro_follow_ups', $data_rec);
				$id = $this->db->insert_id();
			}
		}
		
		$varcompid = $_POST['sess_compid']; 
		$_POST['follup_for'] = $_POST['userid'];
					
		$sql = "select title, id from teampro_groups where compid = $varcompid order by title";
		$data['connect_list'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		
		$sql = "select code_name, code1 from ainf_vps3_code_manager where code_group = 'follup_sort_types' order by code_name";
		$data['follup_sort_types_list'] = $this->db->query($sql)->result_array();
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'follup_contact_types' order by code_name";
		$data['follup_contact_types'] = $this->db->query($sql)->result_array();		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['team_visitor_list'] = $this->db->query($sql)->result_array();
		
		// // //// // // // // // // // // echo   "<br>!! The post add rec is {$_POST['add_record']} !! mod rec is  {$_POST['mod_record']} ";
		
		If ($_POST['return_to_list'] == "yes") {
			redirect('/follow_ups/details/follow_ups'); // back to listing 
		} elseif ($_POST['add_record'] == "yes") {
			$_POST['id'] = 0;
			$this->load->view('update_followups', $data);
		} elseif ($_POST['mod_record'] == "yes" or $_POST['id'] > 0) { // the id is always set from default record 
			// back to updates 
			if ($_POST['id'] > 0) {$id = $_POST['id'];}
			$sql = "select * from teampro_follow_ups where id = $id";			
			$data['edit_teampro_follow_ups'] = $this->db->query($sql)->result_array();
			$_POST['userid'] = $id;
			$this->load->view('update_followups', $data);
		}
	}

	public function event_syst_edit()
	{

		$varcompid = $_POST['sess_compid'];

		if ($_POST['add_followup'] == "yes") {
			$this->follow_up_edit();
		} else {
			if (isset($_POST['followsys_title'])) {
				$data_rec2 = array();
				$data_rec2['compid'] = $varcompid; $data_rec2['mastercompid'] = 113;
				 
				// Generic match allows prefixed fields to add easier to related table - simpler smarter code/table fields 
				foreach($_POST as $key => $value) {
					if (strpos($key,'followsys_') !== false) {
						$data_rec2[$key] = $value;
						// // //// // // // // // // // // echo   "<br>!! key2 is $key2 value is $value";
					}
				}
				// UPDATE MAIN TEAMPRO_FOLLOW_UPS_SYSTEM TABLE 
				if ($_POST['id'] != 0) {
					$data_rec2 = $this->clear_sess_data_array($data_rec2);
					$this->db->where('id', $_POST['id']);
					$this->db->update('teampro_follow_ups_system', $data_rec2);
					$id = $_POST['id'];
				} else {
					$data_rec['compid'] = $varcompid;
					$data_rec['event_songs'] = "0,0";
					$data_rec2 = $this->clear_sess_data_array($data_rec2);
					$this->db->insert('teampro_follow_ups_system', $data_rec2);
					$id = $this->db->insert_id();
				}
			}
		}
		
		if ($_POST['mod_view_image_x'] != "") {
			$_POST['main_action'] = "view";
		} else {
			$_POST['main_action'] = "edit";
		}

		$varcompid = $_POST['sess_compid'];
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['event_leaders'] = $this->db->query($sql)->result_array();
		$sql = "select userid, first_name, last_name, compid from ainf_vps3_users where compid = $varcompid and is_visitor not in ('yes')";
		$data['event_follow_ups'] = $this->db->query($sql)->result_array();
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'Sex' order by code_name";
		$data['sex_list'] = $this->db->query($sql)->result_array();
		$sql = "select title, id from teampro_groups where compid = $varcompid order by title";
		$data['connect_list'] = $this->db->query($sql)->result_array();
		$sql = "select * from teampro_events where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'next_steps' order by code_name";
		$data['next_steps_list'] = $this->db->query($sql)->result_array();
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'event_repeat' order by code_name";
		$data['repeat_types'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_code_manager where code_group = 'follow_frequency'";
		$data['follow_freq'] = $this->db->query($sql)->result_array();			
		$sql = "select * from ainf_vps3_code_manager where code_group = 'event_type'";
		$data['event_types'] = $this->db->query($sql)->result_array();
		$varsql = "";
		$sql = "select * from ainf_vps3_code_manager where code_group = 'proteam-access' $varsql order by code_id desc";
		$data['access_levels'] = $this->db->query($sql)->result_array();

		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'event_team_type' order by code_name";
		$data['event_team_types'] = $this->db->query($sql)->result_array();
		$sql = "select userid, first_name, last_name, compid from ainf_vps3_users where compid = $varcompid or compid_group like '%,$varcompid,%'";
		$data['potential_team_members'] = $this->db->query($sql)->result_array();
		$sql = "select * from teampro_songs where compid = $varcompid or compid = 0 order by song_title";
		$data['song_list'] = $this->db->query($sql)->result_array();
		
		if ($_POST['id'] > 0 and $_POST['id'] != "") {
			$id = $_POST['id'];
			$sql = "select first_name, last_name, compid from ainf_vps3_users where userid in (select leader from teampro_events where id = $id)";
			$data['leader_name'] = $this->db->query($sql)->result_array();
		}
		
		if ($_POST['id'] > 0 and $_POST['id'] != "") {
			$id = $_POST['id'];
			$sql = "select a.id, a.event_id, a.compid, a.event_id, a.team_userid, a.team_type, b.first_name, b.last_name, b.mobile, b.email from teampro_event_teams a 
			left join ainf_vps3_users b on a.team_userid = b.userid where event_id = $id order by team_type";
			$data['event_teams'] = $this->db->query($sql)->result_array();
		}
		
		If ($_POST['return_to_list'] == "yes") {
			redirect('/events3/followups_sys/event_syst_list'); // back to listing 
		} elseif ($_POST['mod_record'] == "yes" OR $_POST['id'] > 0 or $id != "") { // the id is always set from default record 
			// back to updates 
			if ($_POST['id'] > 0 and $_POST['id'] != "") {$id = $_POST['id'];}
			$sql = "select * from teampro_follow_ups_system where id = $id";
			$data['edit_eventsys'] = $this->db->query($sql)->result_array();
			$_POST['userid'] = $id;
			$this->load->view('update_event_syst', $data);
		} else {
			$_POST['userid'] = 0;
			$this->load->view('update_event_syst', $data);
			// // //// // // // // // // // // echo   "<br>!! userid {$_POST['userid']} id is $id ";
		}
	}

	public function event_edit()
	{

		// echo "<br>!! 000 dump post";
		// var_dump($_POST);
		
		$zoom_rec = array();
		$zoom_rec['zoom_url'] = $_POST['zoom_url']; $zoom_rec['zoom_login'] = $_POST['zoom_login']; $zoom_rec['zoom_password'] = $_POST['zoom_password']; 
		$zoom_rec['address_city'] = $_POST['address_city']; $zoom_rec['address_map'] = $_POST['address_map']; 
		if (trim($_POST['active'] == "Y")) {
			$zoom_rec['active'] = "Y";} else { $zoom_rec['active'] = "N";}
			
		$zoom_rec['transport_train_station'] = $_POST['transport_train_station']; $zoom_rec['transport_buses'] = $_POST['transport_buses'];
		unset($_POST['active']); unset($_POST['zoom_url']); unset($_POST['zoom_login']); unset($_POST['zoom_password']); unset($_POST['address_city']); unset($_POST['transport_train_station']); unset($_POST['transport_buses']);
		unset($_POST['address_map']);
		$varcompid = $_POST['sess_compid'];
		
		// // // echo "<br>!! 001 ";
		
		if ($function == "registertoday") { // GET LIST OF EVENTS FOR PULL-DOWN AND SELECT DEFAULT
			$tom = new DateTime('tomorrow');
			$tom_fmt = $tom->format('Y/m/d');
			$sql = "select * from teampro_events where event_type = 'Regular Service' and date_sort < '$tom_fmt' and compid = $varcompid order by date_sort desc"; 
			$data['events_last_month'] = $this->db->query($sql)->result_array(); 
			$num_events = 0;
			if (!isset($_POST['event_id_default']) or $_POST['event_id_default'] == "") { // GET LIST OF EVENTS FOR PULL-DOWN AND SELECT DEFAULT 
				foreach ($data['events_last_month'] as $i) { // GET THE FIRST EVENT AS DEFAULT 
					++$num_events;
					if ($num_events == 1) {
						$_POST['event_id_default'] = $i['id']; // DEFAULT IS CLOSEST TO TODAY 
						// // //// // // // // // // // // echo   "default is {$_POST['event_id_default']}";
					}
				}
			}
		} else {
			// $_POST['event_id_default'] = ""; // DEFAULT IS CLOSEST TO TODAY 
		}
		
		// // // echo "<br>!! 002 ";
		
		if ($_POST['register_image_x'] != "" and isset($_POST['register_image_x'])) {
			$_POST['redirect-from-event-edit'] = "yes";
			$this->attendance();
			// redirect('/events3/attendance/update_attendance'); // back to listing
		} else {
		// // // echo "<br>!! 002b ";
			if ($_POST['add_followup'] == "yes") {
				$this->follow_up_edit();
			} else {

		// // // echo "<br>!! 002c ";
				// ADD ATTENDEES 
				if ($_POST['add_first_name'] != "" and $_POST['add_mobile'] != "") {
					
					$sql = "select * from ainf_vps3_users where compid = $varcompid and mobile = '{$_POST['add_mobile']}' limit 0,1"; 
					$this_mobile = $this->db->query($sql)->result_array(); 
					
					if (count($this_mobile) > 0) {
						$data_rec2 = array();
						foreach ($this_mobile as $i) { // UPDATE ONLY IF NOT REGISTERED ALREADY 
							$var_search_event = "," . $_POST['event_id_default'] . ",";
							if (strpos($i['events_attended'],$var_search_event) === false) { // only add event once 
								$new_event_id = ",0," . $_POST['event_id_default'] . ","; // Take event from pull-down 
								$data_rec2['events_attended'] = str_replace(",0,", $new_event_id, $i['events_attended']);
								
								$data_rec2 = $this->clear_sess_data_array($data_rec2);
								$this->db->where('userid', $i['userid']);
								$this->db->update('ainf_vps3_users', $data_rec2);
							} else {
								// // //// // // // // // // // // echo   "<br>NO UPDATE USER ALREADY IN EVENT";
							}
						}
					} else {
						//## THIS IS FOR A NEW VISITOR TODAY  
						$data_rec2 = array(); 
						$data_rec2['events_attended'] = ",0," . $_POST['event_id_default'] . ","; 
						$data_rec2['compid'] = $varcompid; $data_rec2['first_name'] = $_POST['add_first_name']; $data_rec2['email'] = $_POST['add_email']; 
						$data_rec2['last_name'] = $_POST['add_last_name']; $data_rec2['mobile'] = $_POST['add_mobile']; 
						$data_rec2['start_date_sort'] = date('Y/m/d'); $data_rec2['start_date'] = date('d/m/Y'); 
						$data_rec2 = $this->clear_sess_data_array($data_rec2);
						$this->db->insert('ainf_vps3_users', $data_rec2);
					}
				} elseif (isset($_POST['gen_title'])) {
					$data_rec = array();
					$data_rec = $_POST;

					unset($data_rec['userid']);
					unset($data_rec['id']); unset($data_rec['return_to_list']); unset($data_rec['MAX_FILE_SIZE']);
					unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);
					unset($data_rec['team_userid']); unset($data_rec['team_type']);
					unset($data_rec['main_action']); unset($data_rec['add_song']);
					unset($data_rec['vid_title']); unset($data_rec['teaser']);
					unset($data_rec['series']); unset($data_rec['book']);

					unset($data_rec['sch_type']); unset($data_rec['sch_title']);
					unset($data_rec['sch_person']); unset($data_rec['sch_order']);

					$var_video_id = "";
					if ($_POST['vid_title'] != "" and $_POST['teaser'] != "") {
						$data_rec2 = array();
						$data_rec2['title'] = $_POST['vid_title']; $data_rec2['teaser'] = $_POST['teaser']; 
						$data_rec2['series'] = $_POST['series']; $data_rec2['book'] = $_POST['book']; 
						$data_rec2['compid'] = $varcompid; $data_rec2['message'] = $_POST['message'];
						if ($_POST['video_id'] == 0) {
							$data_rec2 = $this->clear_sess_data_array($data_rec2);
							$this->db->insert('ainf_xcloud_videos', $data_rec2);
							$var_video_id = $this->db->insert_id();
						} else {
							$data_rec2 = $this->clear_sess_data_array($data_rec2);
							$this->db->where('id', $_POST['video_id']);
							$this->db->update('ainf_xcloud_videos', $data_rec2);
						}
					}

					// ADD SONGS 
					$var_song_string = ",{$_POST['add_song']},"; // Only add if song selected and not included
					if ($_POST['add_song'] != "" and $_POST['add_song'] != "0" and strpos($var_song_string, $_POST['event_songs']) === false) {
						$new_song_string = "0," . $_POST['add_song'] . ",";
						$data_rec['event_songs'] = str_replace("0,", $new_song_string, $_POST['event_songs']);
					}
					// REMOVE SONGS
					if ($_POST['add_song'] != "" and $_POST['add_song'] != "0" and strpos($var_song_string, $_POST['event_songs']) === false) {
						$new_event_songs = "0," . $_POST['add_song']; // set the full string of songs to include one just added
					} else {
						$new_event_songs = "0"; // set the full string of songs to zero
					}
					$var_songid_array = explode(",",$_POST['del_songids']);
					$elem_num = count($var_songid_array);
					for ($i = 0; $i <= $elem_num; $i++) {
						if (trim($var_songid_array[$i]) != "") {
							$var_field = "del_song_" . $var_songid_array[$i];
							unset ($data_rec[$var_field]);
							if (isset($_POST[$var_field]) and $_POST[$var_field] == "yes") {
								// // //// // // // // // // // // echo   "<br>We will delete song $var_field";
							} else {
								// // //// // // // // // // // // echo   "<br>We will not delete song $var_field";
								$new_event_songs .= "," . $var_songid_array[$i];
							}
						}
					}
					
					unset ($data_rec['add_first_name']); unset ($data_rec['add_last_name']); unset ($data_rec['add_email']); unset ($data_rec['add_mobile']);
					unset ($data_rec['del_songids']);
					unset ($data_rec['del_team_userids']);
					unset ($data_rec['del_team_']);
					
					$new_event_songs .= ",0"; // We encase the string in 0,0 to allow easier work on the song list 
					$data_rec['event_songs'] = $new_event_songs; // set the full list for updating - so can add and delete at same time 
					
					// ADD TEAM MEMBERS - UNLIKE SONGS TEAMS HAVE ANOTHER TABLE AS WE GIVE PEOPLE DIFF TYPES FOR THEIR ROLE - SAME PERSON CAN HAVE DIFF ROLES IN DIFF EVENTS 
					
					if ($_POST['team_type'] != "" and $_POST['team_userid'] != "" and $_POST['team_userid'] != "0") {
		// // // // echo "<br>!! 33jj ";
			
						$data_team = array();
						$data_team['team_type'] = $_POST['team_type'];
						$data_team['team_userid'] = $_POST['team_userid'];
						$data_team['event_id'] = $_POST['id'];
						$data_team['compid'] = $varcompid;
						$data_team = $this->clear_sess_data_array($data_team);
						$this->db->insert('teampro_event_teams', $data_team);
					}
					
			// // // // // // // // // echo   "<br>!!77bb";
					if ($_POST['team_speakerid'] != "" and $_POST['team_speakerid'] != "0") {
						$data_team = array();
		// // // // echo "<br>!! 33kk ";
			// // // // // // // // // echo   "<br>!!88";
						$data_team['team_type'] = "Service/Event Speaker";
						$data_team['team_userid'] = $_POST['team_speakerid'];
						$data_team['event_id'] = $_POST['id'];
						$data_team['compid'] = $varcompid;
						$data_team = $this->clear_sess_data_array($data_team);
						$this->db->insert('teampro_event_teams', $data_team);
					}

			// // // // // // // // // echo   "<br>!!88 bb";
					// DEL TEAM MEMBERS 
					$var_team_userid_array = explode(",",$_POST['del_team_userids']);
					$elem_num = count($var_team_userid_array);
		// // // // echo "<br>!! 33mm ";
					for ($i = 0; $i <= $elem_num; $i++) {
						if (trim($var_team_userid_array[$i]) != "") {
							$var_field = "del_team_" . $var_team_userid_array[$i];
							unset ($data_rec[$var_field]);
							if (isset($_POST[$var_field]) and $_POST[$var_field] == "yes") {
								// // //// // // // // // // // // echo   "<br>We will delete TEAM $var_field";
			// // // // // // // // // echo   "<br>!!99";
								$this->db->where('id', $var_team_userid_array[$i]);
								$this->db->delete('teampro_event_teams');
							}
						}
					}
					
					// ### Updates / Insert the MAIN event record and SCHEDULE RECORD using gen_ prefix fields 
					// ### Add in more fields from POST 
					$this->update_insert_event_schedule();
					$id = $_POST['id'];

				}
				
				if ($_POST['id'] != "") {
					$sql = "select * from event_schedule where event_id = {$_POST['id']} order by sch_order";
					$data['event_sched'] = $this->db->query($sql)->result_array();
				}
				
				if ($_POST['mod_view_image_x'] != "") {
					$_POST['main_action'] = "view";
				} else {
					$_POST['main_action'] = "edit";
				}
				
				$varcompid = $_POST['sess_compid'];
				$var_compid_sharing = "0,0";
				$sql = "select compid_sharing, globcompid from ainf_xglobalclient where globcompid = $varcompid";
				$get_compid_sharing = $this->db->query($sql)->result_array();
				foreach ($get_compid_sharing as $x) { 
					$var_compid_sharing = $x['compid_sharing']; 
				} 
			
				$varcompid = $_POST['sess_compid'];
				$sql = "select * from ainf_xglobalclient where globcompid = $varcompid";
				$data['organisation'] = $this->db->query($sql)->result_array();
				$sql = "select * from ainf_xcloud_videos, ainf_vps3_users where ainf_xcloud_videos.compid = $varcompid and teacher_userid = ainf_vps3_users.userid and active in ('Y') order by message_date_sort desc ";
				$data['video_list'] = $this->db->query($sql)->result_array();
				$sql = "select * from ainf_vps3_users where is_speaker = 'yes' and compid = $varcompid";
				$data['team_speakers'] = $this->db->query($sql)->result_array();
				// #### this gets leaders from other circle events 
				$sql = "select * from ainf_vps3_users where compid = $varcompid or userid in (select leader from teampro_events where compid in ($var_compid_sharing)) ";
				$data['event_leaders'] = $this->db->query($sql)->result_array();
				// // var_dump($data['event_leaders']);
				
				$sql = "select userid, first_name, last_name, compid from ainf_vps3_users where compid = $varcompid and is_visitor not in ('yes')";
				$data['event_follow_ups'] = $this->db->query($sql)->result_array();
				$sql = "select code_name from ainf_vps3_code_manager where code_group = 'Sex' order by code_name";
				$data['sex_list'] = $this->db->query($sql)->result_array();
				$sql = "select title, id from teampro_groups where compid = $varcompid order by title";
				$data['connect_list'] = $this->db->query($sql)->result_array(); 
				$sql = "select * from teampro_events where compid = $varcompid";
				$data['host_names'] = $this->db->query($sql)->result_array(); 
				$sql = "select code_name from ainf_vps3_code_manager where code_group = 'next_steps' order by code_name";
				$data['next_steps_list'] = $this->db->query($sql)->result_array(); 
				$sql = "select code_name from ainf_vps3_code_manager where code_group = 'event_repeat' order by code_name";
				$data['repeat_types'] = $this->db->query($sql)->result_array(); 
				
				$sql = "select * from ainf_vps3_code_manager where code_group = 'follow_frequency'";
				$data['follow_freq'] = $this->db->query($sql)->result_array(); 
				$sql = "select * from ainf_vps3_code_manager where code_group = 'event_type'";
				$data['event_types'] = $this->db->query($sql)->result_array(); 
				$varsql = "";
				$sql = "select * from ainf_vps3_code_manager where code_group = 'proteam-access' $varsql order by code_id desc";
				$data['access_levels'] = $this->db->query($sql)->result_array(); 

				$sql = "select code_name from ainf_vps3_code_manager where code_group = 'event_team_type' order by code_name";
				$data['event_team_types'] = $this->db->query($sql)->result_array();
				$sql = "select userid, first_name, last_name, compid from ainf_vps3_users where compid = $varcompid or compid_group like '%,$varcompid,%'";
				$data['potential_team_members'] = $this->db->query($sql)->result_array();
				$sql = "select * from teampro_songs where compid = $varcompid or compid = 0 order by song_title";
				$data['song_list'] = $this->db->query($sql)->result_array();
				$sql = "select * from `ainf_vps3_code_manager` where code_group = 'bible_books' order by code_id";
				$data['bible_books'] = $this->db->query($sql)->result_array();
				
				//### SERVICE ORDER CODE 
				if (trim($_POST['serv_item_type']) != "" and $_POST['order_seq'] != "") {
					$data_rec2 = array();
					$data_rec2['event_id'] = $_POST['id']; $data_rec2['order_seq'] = $_POST['order_seq'];
					$data_rec2['order_title'] = $_POST['order_title']; $data_rec2['order_details'] = $_POST['order_details'];
					$data_rec2['serv_item_type'] = $_POST['serv_item_type']; $data_rec2['serv_song_id'] = $_POST['serv_song_id'];
					$data_rec2['compid'] = $varcompid;
					$data_rec2 = $this->clear_sess_data_array($data_rec2);
					$this->db->insert('service_order2', $data_rec2);
				}
				
				if ($id != "") {
					$sql = "select a.id, a.serv_item_type, a.order_details, a.serv_song_id, a.order_seq, a.order_seq_sub, a.order_title, b.id, b.song_title, b.song_best_key, b.active from service_order2 a 
					left join teampro_songs b on a.serv_song_id = b.id where a.event_id = $id order by order_seq"; 
					$data['order_list'] = $this->db->query($sql)->result_array(); 
				}
				$sql = "select code_name from ainf_vps3_code_manager where code_group = 'order_service_type' order by code_name";
				$data['order_types'] = $this->db->query($sql)->result_array();
				$sql = "select code_name from ainf_vps3_code_manager where code_group = 'order_seq' order by code_name";
				$data['seq_list'] = $this->db->query($sql)->result_array();
				
				if ($_POST['id'] > 0 and $_POST['id'] != "") {
					$id = $_POST['id'];
					$sql = "select first_name, last_name, compid from ainf_vps3_users where userid in (select leader from teampro_events where id = $id)";
					$data['leader_name'] = $this->db->query($sql)->result_array();
				}
				
				if ($_POST['id'] > 0 and $_POST['id'] != "") {
					$id = $_POST['id'];
					$sql = "select a.id, a.event_id, a.compid, a.event_id, a.team_userid, a.team_type, b.first_name, b.last_name, b.mobile, b.email from teampro_event_teams a 
					left join ainf_vps3_users b on a.team_userid = b.userid where event_id = $id order by team_type";
					$data['event_teams'] = $this->db->query($sql)->result_array();
				}

				// ### VISITORS ATTENDEES IN LAST WEEK 

				$new_visitors_date = date('Y/m/d', strtotime('-7 days')); 
				$var_search_event = "," . $_POST['event_id_default'] . ","; 
				$sql = "select userid, first_name, last_name, mobile, email, compid, events_attended, start_date, start_date_sort from ainf_vps3_users where (compid = $varcompid or compid_group  like '%,$varcompid,%') and start_date_sort > '$new_visitors_date' 
				and events_attended like '%$var_search_event%' order by start_date_sort desc"; 
				$data['event_attendees_new'] = $this->db->query($sql)->result_array(); 
				
				// ### REGULARS BEYOND LAST WEEK 
				// $var_search_event = "," . $_POST['id'] . ","; 
				$var_search_event = "," . $_POST['event_id_default'] . ","; 
				$sql = "select userid, first_name, last_name, mobile, email, compid, events_attended, start_date, start_date_sort from ainf_vps3_users where (compid = $varcompid or compid_group  like '%,$varcompid,%') and start_date_sort < '$new_visitors_date' 
				and events_attended like '%$var_search_event%' order by start_date_sort desc"; 
				$data['event_attendees_regular'] = $this->db->query($sql)->result_array();
				
				if ($_POST['event_id_default'] != "") {
					$_POST['id'] = $_POST['event_id_default']; // load the id from the default for reigstrations for today 
				} 
				
				If ($_POST['return_to_list'] == "yes") {
					redirect('/events3/details/service_list'); // back to listing 
				} elseif ($_POST['mod_record'] == "yes" OR $_POST['id'] > 0) { // the id is always set from default record 
					// back to updates 
					if ($_POST['id'] > 0) {$id = $_POST['id'];} 
					$sql = "select a.address_suburb, a.address_postcode, a.address_map, a.transport_buses, a.transport_train_station, a.zoom_url, a.zoom_login, a.zoom_password, a.video_id, a.ev_intro_video, a.event_songs, a.users_attended, a.event_repeat, a.ev_tot_tracts_given, a.ev_tot_decisions, a.ev_milestone_date_1, a.ev_milestone_map_1, a.ev_milestone_note_1, a.ev_milestone_title_1, a.ev_milestone_date_2, a.ev_milestone_map_2, a.ev_milestone_note_2, a.ev_milestone_title_2, a.event_type, a.compid, a.details, a.leader, a.date, a.date_sort, a.title, a.event_tip, 
					a.active, a.address, a.address_city, a.contact_1, a.contact_2, a.duration_note, a.transport_1, a.transport_2, a.image_url, a.id, b.title as vid_title , b.teaser, b.series, b.book, b.message from teampro_events a 
					left join ainf_xcloud_videos b on a.video_id = b.id 
					where a.id = $id"; 
					$data['edit_teampro_event'] = $this->db->query($sql)->result_array();
					// // var_dump($data['edit_teampro_event']);
					$_POST['userid'] = $id;
					if (strpos($_SERVER['REQUEST_URI'], '/registertoday') !== false) {
						$this->load->view('update_event_register', $data);
					} else {
						$this->load->view('update_event', $data);
					}
				} else {
					$_POST['userid'] = 0;
					if (strpos($_SERVER['REQUEST_URI'], '/registertoday') !== false) {
						$this->load->view('update_event_register', $data);
					} else {
						$this->load->view('update_event', $data);
					}
				}
			}
		}
	}
	
	public function update_insert_event_schedule()
	{
		
		$data_rec_eve = array(); 
		// ### THIS IS HERE TO SIMPLIFY THE MAIN FUNCTION BY MOVING CODE OUTSIDE  
		// ### 1. ARRAY KEY FIELD LOAD LOAD FIELDS AS PREFIX gen_ FOR THE MAIN TABLE 
		// echo "<br>!! aa date  GEN IS {$_POST['gen_date']}";
		foreach($_POST as $key => $value) { 
			if (strpos($key,'gen_') !== false) { 
				$var_key_mod = str_replace('gen_','',$key); 
				$data_rec_eve[$var_key_mod] = $_POST[$key]; 
				// // // echo "<br>Key is $key key_mod $var_key_mod, value $value"; 
			} 
		} 

		// ### 2. CUSTOM GENERATED FIELDS - MUST WORK WITH $data_rec_eve ARRAY IS LOADED 
		$date_array = explode('/',substr($data_rec_eve['date'], 0, 10)); // invert date and drop time for date_sort 
		$data_rec_eve['date_sort'] = $date_array[2] . "/" . $date_array[1] . "/" . $date_array[0]; 
		
		// // var_dump($data_rec_eve); 

		if ($_POST['id'] != 0) {
			
			$this->db->where('id', $_POST['id']); 
			$this->db->update('teampro_events', $data_rec_eve); 

		} else {

			$data_rec_eve['compid'] = $_POST['sess_compid'];
			$data_rec_eve['event_songs'] = "0,0";
			$this->db->insert('teampro_events', $data_rec_eve);
			$id = $this->db->insert_id();
			$_POST['id'] = $id;
		}
		
		// ### 2). UPDATE EVENT SCHEDULE ITEM 
		if ($_POST['sch_type'] != "" and $_POST['sch_title'] != "") {
			$data_rec = array();
			$data_rec['event_id'] = $_POST['id'];
			$data_rec['sch_type'] = $_POST['sch_type'];
			$data_rec['sch_title'] = $_POST['sch_title'];
			$data_rec['sch_person'] = $_POST['sch_person'];
			$data_rec['sch_order'] = $_POST['sch_order'];
			$data_rec['compid'] = $_POST['sess_compid'];
			$data_rec = $this->clear_sess_data_array($data_rec); 
			$this->db->insert('event_schedule', $data_rec);
		}
				
	}
	
	public function meeting_edit()
	{
		
		$varcompid = $_POST['sess_compid'];
		if (isset($_POST['title'])) {
			$data_rec = array();
			$data_rec = $_POST; 
			unset($data_rec['userid']); 
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);

			if ($_POST['id'] != 0) {
				$data_rec = $this->clear_sess_data_array($data_rec);
				$this->db->where('id', $_POST['id']);
				$this->db->update('teampro_groups', $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$data_rec['mastercompid'] = 113;
				$data_rec = $this->clear_sess_data_array($data_rec);
				$this->db->insert('teampro_groups', $data_rec);
				$id = $this->db->insert_id();
			}
		}
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		If ($_POST['return_to_list'] == "yes") {
			redirect('/teams2/details/index'); // back to listing
		} elseif ($_POST['mod_record'] == "yes") { // the id is always set from default meeting 
			// back to updates 
			if ($_POST['id'] > 0) {$id = $_POST['id'];} 
			$sql = "select * from teampro_events where id = $id";
			$data['edit_teampro_groups'] = $this->db->query($sql)->result_array();
			$_POST['id'] = $id;
			$this->load->view('update_meetings', $data);
		} else {
			$_POST['id'] = 0;
			$this->load->view('update_meetings', $data);
		}
	}
	
	public function attendance()
	{
		
		// Set the sub-querys 
		$var_at_this_event = "%," . $_POST['id'] .  ",%"; // Sub-query locating that event 
				
		$varcompid = $_POST['sess_compid'];
		if (isset($_POST['first_name'])) {

			// Find user from mobile 
			$var_mobile = trim($_POST['mobile']);
			if (trim($var_mobile) != "") {
				$sql = "select * from ainf_vps3_users where mobile = $var_mobile";
				$data['new_attendee'] = $this->db->query($sql)->result_array();
			}
			// // //// // // // // // // // // echo   "<br>!! xx "; //// // // // var_dump($data['new_attendee']);
			
			if (count($data['new_attendee']) > 0 and $var_mobile != "") { // this attendee has registered before - we can add them in 
				foreach ($data['new_attendee'] as $rec) {
					$var_events_attended = $rec['events_attended'];
					$var_userid = $rec['userid'];
					$var_this_event_string = "," . $_POST['id'] .  ","; // to check if they are registered they would have this substr
					// // //// // // // // // // // // echo   "<br>!! cc var_events_attended $var_events_attended";
						} if (strpos($var_events_attended, $var_this_event_string) !== false) {
							// Already registered for this event
						} else {
							if (trim($var_events_attended) == "") { // On record but not attended
								$var_events_attended = "0," . $_POST['id'] .  ",0"; // Sub-query locating that event
								// // //// // // // // // // // // echo   "<br>!!dda NEW var_events_attended $var_events_attended, ";
							} else {  // On record and attended already
								$var_str_replace = "0," . $_POST['id'] .  ",";
								$var_events_attended_new = str_replace( "0," , $var_str_replace  , $var_events_attended );
								// // //// // // // // // // // // echo   "<br>!!XX After replace str_replace $var_str_replace, var_events_attended= $var_events_attended, var_events_attended_new= $var_events_attended_new";
								$var_events_attended = $var_events_attended_new;
							}
							$data_rec = array();
							$data_rec['events_attended'] = $var_events_attended;
							$data_rec = $this->clear_sess_data_array($data_rec);
							$this->db->where('userid', $var_userid);
							$this->db->update('ainf_vps3_users', $data_rec);
						}
			} else {
				// NEW VISITOR NOT ON RECORD AT ANY CHURCH 
				$var_events_attended = "0," . $_POST['id'] .  ",0"; // Make present for this church 
				$data_rec = array();
				$data_rec['events_attended'] = $var_events_attended;
				$data_rec['first_name'] = $_POST['first_name'];
				$data_rec['last_name'] = $_POST['last_name'];
				$data_rec['mobile'] = $_POST['mobile']; $data_rec['email'] = $_POST['email']; $data_rec['compid'] = $varcompid;
				$data_rec['sex'] = $_POST['sex']; $data_rec['followup_person'] = $_POST['followup_person']; 
				$data_rec['is_visitor'] = "yes";
				$data_rec = $this->clear_sess_data_array($data_rec);
				$this->db->insert('ainf_vps3_users', $data_rec);
			}
			
		}
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		$sql = "select userid, first_name, last_name, compid from ainf_vps3_users where compid = $varcompid and is_leader = 'yes'";
		$data['event_follow_ups'] = $this->db->query($sql)->result_array();
		$sql = "select userid, first_name, last_name, compid from ainf_vps3_users where compid = $varcompid and is_visitor not in ('yes')";
		$data['event_follow_ups'] = $this->db->query($sql)->result_array();
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'Sex' order by code_name";
		$data['sex_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid and userid not in (select userid from ainf_vps3_users where events_attended like '$var_at_this_event')";
		$data['attendees_not_present'] = $this->db->query($sql)->result_array();
		
		// ANALYTICS FOR EVENT 
		$sql = "select * from ainf_vps3_users where events_attended like '$var_at_this_event'";
		$data['attendees_present'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where events_attended like '$var_at_this_event' and sex = 'Male'";
		$data['attendees_present_male'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where events_attended like '$var_at_this_event' and (mobile is not null and mobile <> '' and (email is null or email = ''))";
		$data['attendees_present_left_phone'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where events_attended like '$var_at_this_event' and ((mobile is null or email = '') and (email is not null and email <> ''))";
		$data['attendees_present_left_email'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where events_attended like '$var_at_this_event' and (mobile is not null and mobile <> '' and email is not null and email <> '')";
		$data['attendees_present_left_phoneandemail'] = $this->db->query($sql)->result_array();

		$var_this_event_only = "0," . $_POST['id'] .  ",0"; // Sub-query locating that event
		$sql = "select * from ainf_vps3_users where compid = $varcompid and events_attended = '$var_this_event_only' and is_visitor = 'yes'";
		$data['visitors_present'] = $this->db->query($sql)->result_array();
		
		if ($_POST['id'] > 0) {
			$id = $_POST['id'];
			$sql = "select * from teampro_events where id = $id";
			$data['this_event'] = $this->db->query($sql)->result_array();
		}
		$sql = "select * from teampro_events where compid = $varcompid";
		$data['edit_teampro_events'] = $this->db->query($sql)->result_array();
		$_POST['id'] = $id;
		$this->load->view('update_attendance', $data);
	}

	
	public function details($pagename)
	{

		$this->Asys_multi8->run_check(); // Ensure events are up to date 
		redirect('/events3/details2/manage_key_lists_4', 'refresh'); 
	
	} 

	public function details2($pagename)
	{
		
		error_reporting(0);
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();

		$varcompid = $_POST['sess_compid'];
		$var_compid_sharing = "0,0";
		$sql = "select compid_sharing, globcompid from ainf_xglobalclient where globcompid = $varcompid";
		$get_compid_sharing = $this->db->query($sql)->result_array();
		foreach ($get_compid_sharing as $x) {
			$var_compid_sharing = $x['compid_sharing'];
			// // // // // // echo "!! NEW compid share is $var_compid_sharing";
		}
		
		if ($_POST['add_followup'] == "yes" or $_POST['add_followup2'] == "yes") {
			$this->follow_up_edit();
		}

		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// // // // // // echo "<br>!!22 ";
		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list 
		
		$varcompid = $_POST['sess_compid'];
		$var_search = "";
		
		// Process the form filter
		if (isset($_POST['form_reset'])) { // reset the form values
			$_POST['form_book'] = "";
			$_POST['form_speaker'] = "";
			$_POST['form_keywords'] = "";
		}
		if ($_POST['form_book'] != "") {
			$var_search .= " and book = '{$_POST['form_book']}' ";
		}
		if ($_POST['form_speaker'] != "") {
			$var_search .= " and teacher = '{$_POST['form_speaker']}' ";
		}

		// // // // // // echo "<br>!!33 ";
		//error_reporting(E_ALL & ~E_NOTICE & ~E_DEPRECATED & ~E_STRICT & ~E_USER_NOTICE & ~E_USER_DEPRECATED);
		$var_sql_range = ""; // Get filters into the sql 

		if ($pagename_orig == "service_list" or isset($_POST['form_event_group']) or strpos($_SERVER['REQUEST_URI'], "events_next") !== false or strpos($_SERVER['REQUEST_URI'], "events_today") !== false or strpos($_SERVER['REQUEST_URI'], "my_events") !== false) {
			if ($pagename_orig == "service_list") {

				//### - START get week and month date ranges for current day 
				$week_var_date_from = date("Y/m"); $week_var_date_from .= "/01 00:00";
				$var_sql_range_month = " and date_sort > '$week_var_date_from' ";
				$d = new DateTime( 'now' ); $var_date_to_month = $d->format( 'Y/m/t' ) . " 24:00";
				$var_sql_range_month .= " and date_sort < '$var_date_to_month' ";
				
				$current_date = date('Y-m-d'); 
				$date = strtotime($current_date); 
				$weekDay = date('w', strtotime($date)); 
				$weekDay = date('w', strtotime('+1 day',$date)); 
				
				if ($weekDay == 0) {$weekDay = 6;} else {--$weekDay;} // adjust to today 
				if(($weekDay == 1)) { // Monday 
					$var_startday = 0; $var_endday = 6;
				} elseif(($weekDay == 2)) { // Tues
					$var_startday = -1; $var_endday = 5;
				} elseif(($weekDay == 3)) { // Wed 
					$var_startday = -2; $var_endday = 4;
				} elseif(($weekDay == 4)) { // Thurs 
					$var_startday = -3; $var_endday = 3;
				} elseif(($weekDay == 5)) { // Fri 
					$var_startday = -4; $var_endday = 2;
				} elseif(($weekDay == 6)) { // Saturday 
					$var_startday = -5; $var_endday = 1;
				} elseif(($weekDay == 0)) { // Sund
					$var_startday = -6; $var_endday = 0;
				}

				$varend = "+$var_endday day"; 
				$week_end_day = date('Y/m/d', strtotime($varend, $date)); 
				$varstart = "$var_startday day"; 
				$week_start_day = date('Y/m/d', strtotime($varstart, $date)); 
				$week_start_day .= " 00:00"; 
				$var_sql_range_week = " and date_sort > '$week_start_day' "; 
				$week_end_day .= " 24:00"; 
				$var_sql_range_week .= " and date_sort < '$week_end_day' "; 
				// // // // // // // echo "<br>!!! week sql is $var_sql_range_week";
				
				$week_var_date_from = date("Y/m"); $week_var_date_from .= "/01 00:00";
				$var_sql_range_month = " and date_sort > '$week_var_date_from' ";
				$d = new DateTime( 'now' ); $var_date_to_month = $d->format( 'Y/m/t' ) . " 24:00";
				$var_sql_range_month .= " and date_sort < '$var_date_to_month' ";
				
				//### - END get week and month date ranges for current day 

			} elseif ($_POST['form_event_group'] == "Past Events") {
				$var_date_from = date("Y/m/d") . " 00:00";
				$var_sql_range = " and date_sort < '$var_date_from'";
			} elseif (strpos($_SERVER['REQUEST_URI'], "my_events")) {
				// $var_sql_range .= " and id in (select event_id from teampro_event_teams where team_userid = {$_POST['sess_userid']}) ";
			} elseif ($_POST['form_event_group'] == "Events Today" or strpos($_SERVER['REQUEST_URI'], "events_today")) {
				$var_date_from = date("Y/m/d") . " 00:00";
				$var_sql_range = " and date_sort > '$var_date_from' ";
				$var_date_today = date("Y-m-d");
				$var_date_to = date('Y/m/d', strtotime($var_date_today. ' + 1 days')) . " 00:00";
				$var_sql_range .= " and date_sort < '$var_date_to' ";
				$_POST['form_event_group'] = "Events Today";
			} elseif ($_POST['form_event_group'] == "Events This Week" or strpos($_SERVER['REQUEST_URI'], "events_next_7_days") !== false) {
				$var_date_from = date("Y/m/d") . " 00:00";
				$var_sql_range = " and date_sort > '$var_date_from' ";
				$var_date_today = date("Y-m-d");
				$var_date_to = date('Y/m/d', strtotime($var_date_today. ' + 8 days')) . " 00:00";
				$var_sql_range .= " and date_sort < '$var_date_to' ";
				$_POST['form_event_group'] = "Events This Week";
			} elseif ($_POST['form_event_group'] == "Events next 30 Days" or strpos($_SERVER['REQUEST_URI'], "events_next_30_days") !== false) {
				$var_date_from = date("Y/m/d") . " 00:00";
				$var_sql_range = " and date_sort > '$var_date_from' ";
				$var_date_today = date("Y-m-d");
				$var_date_to = date('Y/m/d', strtotime($var_date_today. ' + 31 days')) . " 00:00";
				$var_sql_range .= " and date_sort < '$var_date_to' ";
				$_POST['form_event_group'] = "Events next 30 Days";
			} elseif ($_POST['form_event_group'] == "All Events") {
				$var_sql_range = "";
			}
		}
				
		// // // // // // echo "<br>!! 55";
		if (isset($_POST['form_event_type']) and trim($_POST['form_event_type']) != "" and trim($_POST['form_event_type']) != "All Event Types") {
			$var_sql_range .= " and event_type = '{$_POST['form_event_type']}' ";
		}
		

		// // // // // // echo "<br>!! 55 sql is $sql ";
		// $data['events'] = $this->db->query($sql)->result_array();
		
		$var_sql_range = ""; $var_search = "";
		$sql = "select * from teampro_events where compid = $varcompid and active = 'Y' order by date_sort desc";
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'event_type'";
		$data['event_types'] = $this->db->query($sql)->result_array();
		
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		
		$sql = "select id from teampro_groups where compid = $varcompid $subqry $var_search order by message_date_sort desc";
		$data['messages'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from teampro_events where compid = $varcompid $var_sql_range order by date_sort desc";
		$data['events_list'] = $this->db->query($sql)->result_array();
		// //// // // // var_dump($data['events_list']);

		// // // // // // echo "<br>!! 99";

		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
			
		$sql = "select * from teampro_groups where compid = $varcompid order by message_date_sort desc"; 
		$sql = "select * from teampro_groups, ainf_vps3_users where teampro_groups.compid = $varcompid and meeting_host = userid order by message_date_sort desc"; 
		$data['messages'] = $this->db->query($sql)->result_array(); 
								
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid order by request_date desc"; 
		$data['prayer_requests'] = $this->db->query($sql)->result_array();

		$varqry = ""; // Apply the filter 
		if ($_POST['form_follup_for'] != "") {$varqry .= " and follup_for = {$_POST['form_follup_for']} ";} 
		if ($_POST['form_follup_by'] != "") {$varqry .= " and follup_by = {$_POST['form_follup_by']} ";} 
		if ($_POST['form_sort_by'] != "") {$varsort = " order by {$_POST['form_sort_by']} ";} else {$varsort = " order by follup_for, follup_contact_date_sort desc ";} 

		$sql = "select * from teampro_follow_ups, ainf_vps3_users where ainf_vps3_users.compid = $varcompid $varqry and userid = follup_by $varsort"; 
		$data['follow_ups'] = $this->db->query($sql)->result_array(); // show followups per owner 
		
		$sql = "select * from teampro_follow_ups, ainf_vps3_users where ainf_vps3_users.compid = $varcompid $varqry and userid = follup_by and 
		(follup_by = {$_POST['sess_userid']} or follup_for = {$_POST['sess_userid']}) $varsort"; 
		// $data['my_follow_ups'] = $this->db->query($sql)->result_array(); // show followups per owner 
		
		$var_follup_contact_date_time = date('Y/m/d',strtotime("-1 days"));
		$sql = "select * from teampro_follow_ups, ainf_vps3_users where follup_contact_date_sort > '$var_follup_contact_date_time' and ainf_vps3_users.compid = $varcompid and userid = follup_by $varsort"; 
		$data['follow_ups_planned'] = $this->db->query($sql)->result_array(); // show followups per owner 
		// // //// // // // // // // // // echo   "<br>varsql is $sql";
		
		$sql = "select code_name, code1 from ainf_vps3_code_manager where code_group = 'follup_sort_types' order by code_name";
		$data['follup_sort_types_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid order by first_name, last_name";
		$data['team_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct meeting_host from teampro_groups where compid = $varcompid $subqry order by meeting_host";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select first_name, last_name, userid from ainf_vps3_users where ainf_vps3_users.compid = $varcompid and userid in (select distinct follup_by from  teampro_follow_ups) order by first_name, last_name"; 
		$data['list_follup_by'] = $this->db->query($sql)->result_array();
		
		$sql = "select first_name, last_name, userid from ainf_vps3_users where ainf_vps3_users.compid = $varcompid and userid in (select distinct follup_for from  teampro_follow_ups) order by first_name, last_name";
		$data['list_follup_for'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 

		$sql = "select * from cms_images where compid = $varcompid order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid = $varcompid order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason 
		
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid and req_status = 'Open' order by request_date desc";
		$data['prayer_requests_open'] = $this->db->query($sql)->result_array();

		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid and req_status = 'Answered' order by request_date desc";
		$data['prayer_requests_anwered'] = $this->db->query($sql)->result_array();

		// The left join gets the optional leader name 
		$sql = "select a.id, a.event_type, a.compid, a.details, a.leader, a.date, a.date_sort, a.title, a.event_tip, a.address, a.contact_1, a.contact_2, a.duration_note, 
		a.transport_1, a.transport_2, a.image_url, b.first_name as leader_first_name, b.last_name as leader_last_name 
		from teampro_events a 
		left join ainf_vps3_users b on a.leader = b.userid 
		where a.compid = $varcompid $var_sql_range order by date_sort desc"; 
		$data['events_list'] = $this->db->query($sql)->result_array();

		$week_var_date_from = date("Y/m"); $week_var_date_from .= "/01 00:00";
		$var_sql_range_month = " and date_sort > '$week_var_date_from' ";
		$d = new DateTime( 'now' ); $var_date_to_month = $d->format( 'Y/m/t' ) . " 24:00";
		$var_sql_range_month .= " and date_sort < '$var_date_to_month' ";
		
		$current_date = date('Y-m-d'); 
		$date = strtotime($current_date); 
		$weekDay = date('w', strtotime($date)); 
		$weekDay = date('w', strtotime('+1 day',$date)); 
		
		if ($weekDay == 0) {$weekDay = 6;} else {--$weekDay;} // adjust to today 
		if(($weekDay == 1)) { // Monday 
			$var_startday = 0; $var_endday = 6;
		} elseif(($weekDay == 2)) { // Tues
			$var_startday = -1; $var_endday = 5;
		} elseif(($weekDay == 3)) { // Wed 
			$var_startday = -2; $var_endday = 4;
		} elseif(($weekDay == 4)) { // Thurs 
			$var_startday = -3; $var_endday = 3;
		} elseif(($weekDay == 5)) { // Fri 
			$var_startday = -4; $var_endday = 2;
		} elseif(($weekDay == 6)) { // Saturday 
			$var_startday = -5; $var_endday = 1;
		} elseif(($weekDay == 0)) { // Sund
			$var_startday = -6; $var_endday = 0;
		}
		$varend = "+$var_endday day"; 
		$week_end_day = date('Y/m/d', strtotime($varend, $date)); 
		$varstart = "$var_startday day"; 
		$week_start_day = date('Y/m/d', strtotime($varstart, $date)); 
		$week_start_day .= " 00:00"; 
		$var_sql_range_week = " and date_sort > '$week_start_day' "; 
		$week_end_day .= " 24:00"; 
		$var_sql_range_week .= " and date_sort < '$week_end_day' "; 
		
		//### TAB1 Is Now the Full List 
		$sql_fields = " a.id, a.address_suburb, a.address_postcode, a.event_type, a.address_map, a.compid, a.details, a.leader, a.date, a.date_sort, a.title, a.event_tip, a.address, a.address_city, a.contact_1, a.contact_2, a.duration_note, 
		a.active, a.event_repeat, a.transport_1, a.transport_2, a.image_url, a.zoom_url, a.zoom_login, a.zoom_password, a.transport_buses, a.transport_train_station, 
		b.mobile, b.first_name as leader_first_name, b.last_name as leader_last_name, b.team_image_link "; 
		
		$sql = "select $sql_fields from teampro_events a left join ainf_vps3_users b on a.leader = b.userid 
		where a.compid in ($varcompid) and a.active = 'Y' order by date_sort desc"; 
		// // echo "<br>!! tab1 sql - $sql <br> !! {$_SERVER['SERVER_ADDR']} ";

		$sql = "select $sql_fields from teampro_events a left join ainf_vps3_users b on a.leader = b.userid 
		where a.compid in ($varcompid) and a.active = 'Y' order by date_sort desc"; 
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array(); 

		$var_debug_id = "103.245.157.31";
		if ($var_debug_id == $_SERVER['REMOTE_ADDR']) {
			// // echo "<br><br>!! tab1 sql - $sql <br>Client IP {$_SERVER['REMOTE_ADDR']}}"; 
		}

		$sql = "select $sql_fields from teampro_events a left join ainf_vps3_users b on a.leader = b.userid 
		where (a.compid not in ($varcompid) and a.compid in ($var_compid_sharing)) and a.active = 'Y' order by date_sort desc"; 
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array(); 

		if ($var_debug_id == $_SERVER['REMOTE_ADDR']) {
			// // echo "<br><br>!! tab2 sql - $sql <br>Client IP {$_SERVER['REMOTE_ADDR']}}"; 
		}

		$sql = "select $sql_fields from teampro_events a left join ainf_vps3_users b on a.leader = b.userid 
		where event_type = 'Church Service' and (a.compid in ($varcompid) or a.compid in ($var_compid_sharing)) and a.active = 'Y' order by date_sort desc"; 
		// ### EXCLUDE CIRCLE SERVICES FOR NOW 
		$sql = "select $sql_fields from teampro_events a left join ainf_vps3_users b on a.leader = b.userid 
		where event_type = 'Church Service' and (a.compid in ($varcompid)) and a.active = 'Y' order by date_sort desc"; 
		$data['main_list_array_tab3'] = $this->db->query($sql)->result_array();
		
		//### NOT USED TO DATE - This is all events for the CURRENT week month - year date filter 
		$sql = "select $sql_fields from teampro_events a left join ainf_vps3_users b on a.leader = b.userid 
		where a.compid = $varcompid and a.active not in ('Y') order by date_sort"; 
		$data['main_list_array_tab4'] = $this->db->query($sql)->result_array(); 

		//### This is all events for the month - year date filter 
		// The left join gets the optional leader name 
		$week_var_this_month_and_year_sql = " and date_sort like '" . date("Y") . "/" . date("m") . "/%' ";
		$sql = "select $sql_fields from teampro_events a left join ainf_vps3_users b on a.leader = b.userid 
		where event_type = 'Church Service' and (a.compid = $varcompid or a.compid in ($var_compid_sharing)) and a.active = 'Y' order by date_sort"; 

		//### This is all events for the year - year date filter 
		$week_var_this_year = date("Y"); 
		$week_var_this_year_sql = " and date_sort like '$week_var_this_year/%' "; 

		//// //// // // // // // // // // echo   $pagename_orig;exit;
		if (file_exists(base_url("views/manage_key_lists_4")))
		{
			$_POST['error'] = "";
		// // // // // // echo "<br>!!66 ";
			$this->load->view("manage_key_lists_4", $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view("manage_key_lists_4", $data);
			// $this->load->view('index', $data);
		}
		
	}

	public function followups_sys($pagename)
	{
		
		$varcompid = $_POST['sess_compid'];
		if ($_POST['add_followup'] == "yes" or $_POST['add_followup2'] == "yes") {
			$this->follow_up_edit();
		}
		
		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list 
		
		$varcompid = $_POST['sess_compid'];
		$var_search = "";
		
		$var_sql_range = ""; // Get filters into the sql 
				
		if (isset($_POST['form_event_type']) and trim($_POST['form_event_type']) != "" and trim($_POST['form_event_type']) != "All Event Types") {
			$var_sql_range .= " and event_type = '{$_POST['form_event_type']}' ";
		}
		
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}

		$sql = "select * from teampro_follow_ups_system where compid = $varcompid order by followsys_title desc";
		$data['follow_syst_list'] = $this->db->query($sql)->result_array();

		//// //// // // // // // // // // echo   $pagename_orig;exit;
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

	public function visitors($pagename)
	{
		
		error_reporting(0);
		$varcompid = $_POST['sess_compid']; 
		$var_this_event_only = "0," . $_POST['id'] .  ",0"; // Sub-query locating that event 
		
		$var_date_sort = date('Y/m/d');
		$var_date_sort = date('d/m/Y');
		$sql = "select id, date_sort, compid from teampro_events where compid = $varcompid and date_sort like ('%$var_date_sort%')";
		$sql = "select id, date, compid from teampro_events where compid = $varcompid and date like ('%$var_date_sort%')";
		$data['current_events'] = $this->db->query($sql)->result_array();
		$var_current_events_sql = ""; $var_ev_num = 0;
		foreach ($data['current_events'] as $x) {
			$var_current_events_sql .=  " and events_attended like '%,{$x['id']},%'";
		}
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid $var_current_events_sql and is_visitor = 'yes'";
		$data['visitors_present'] = $this->db->query($sql)->result_array();
		
		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list		
		$varcompid = $_POST['sess_compid'];
		$var_search = "";
		
		// Process the form filter
		if (isset($_POST['form_reset'])) { // reset the form values
			$_POST['form_book'] = "";
			$_POST['form_speaker'] = "";
			$_POST['form_keywords'] = "";
		}
		if ($_POST['form_book'] != "") {
			$var_search .= " and book = '{$_POST['form_book']}' ";
		}
		if ($_POST['form_speaker'] != "") {
			$var_search .= " and teacher = '{$_POST['form_speaker']}' ";
		}
		
		$sql = "select * from events where compid = $varcompid order by date_sort desc"; 
		$data['events'] = $this->db->query($sql)->result_array(); 
		
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		
		$sql = "select id from teampro_groups where compid = $varcompid $subqry $var_search order by message_date_sort desc";
		$data['messages'] = $this->db->query($sql)->result_array();

		$sql = "select * from teampro_events where compid = $varcompid order by date_sort desc";
		$data['events_list'] = $this->db->query($sql)->result_array();
		// //// // // // var_dump($data['events_list']);

		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
			
		$sql = "select * from teampro_groups where compid = $varcompid order by message_date_sort desc"; 
		$sql = "select * from teampro_groups, ainf_vps3_users where teampro_groups.compid = $varcompid and meeting_host = userid order by message_date_sort desc"; 
		$data['messages'] = $this->db->query($sql)->result_array(); 								
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid order by request_date desc"; 
		$data['prayer_requests'] = $this->db->query($sql)->result_array();

		$varqry = ""; // Apply the filter 
		if ($_POST['form_follup_for'] != "") {$varqry .= " and follup_for = {$_POST['form_follup_for']} ";} 
		if ($_POST['form_follup_by'] != "") {$varqry .= " and follup_by = {$_POST['form_follup_by']} ";} 
		if ($_POST['form_sort_by'] != "") {$varsort = " order by {$_POST['form_sort_by']} ";} else {$varsort = " order by follup_for, follup_contact_date_sort desc ";} 

		$sql = "select * from teampro_follow_ups, ainf_vps3_users where ainf_vps3_users.compid = $varcompid $varqry and userid = follup_by $varsort"; 
		$data['follow_ups'] = $this->db->query($sql)->result_array(); // show followups per owner 
		
		$sql = "select * from teampro_follow_ups, ainf_vps3_users where ainf_vps3_users.compid = $varcompid $varqry and userid = follup_by and 
		(follup_by = {$_POST['sess_userid']} or follup_for = {$_POST['sess_userid']}) $varsort"; 
		// #### $data['my_follow_ups'] = $this->db->query($sql)->result_array(); // show followups per owner 
		
		$var_follup_contact_date_time = date('Y/m/d',strtotime("-1 days"));
		$sql = "select * from teampro_follow_ups, ainf_vps3_users where follup_contact_date_sort > '$var_follup_contact_date_time' and ainf_vps3_users.compid = $varcompid and userid = follup_by $varsort"; 
		$data['follow_ups_planned'] = $this->db->query($sql)->result_array(); // show followups per owner 
		// // //// // // // // // // // // echo   "<br>varsql is $sql";
		
		$sql = "select code_name, code1 from ainf_vps3_code_manager where code_group = 'follup_sort_types' order by code_name";
		$data['follup_sort_types_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid order by first_name, last_name";
		$data['team_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct meeting_host from teampro_groups where compid = $varcompid $subqry order by meeting_host";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select first_name, last_name, userid from ainf_vps3_users where ainf_vps3_users.compid = $varcompid and userid in (select distinct follup_by from  teampro_follow_ups) order by first_name, last_name"; 
		$data['list_follup_by'] = $this->db->query($sql)->result_array();
		
		$sql = "select first_name, last_name, userid from ainf_vps3_users where ainf_vps3_users.compid = $varcompid and userid in (select distinct follup_for from  teampro_follow_ups) order by first_name, last_name";
		$data['list_follup_for'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 

		$sql = "select * from cms_images where compid = $varcompid order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid = $varcompid order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason 
		
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid and req_status = 'Open' order by request_date desc";
		$data['prayer_requests_open'] = $this->db->query($sql)->result_array();

		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid and req_status = 'Answered' order by request_date desc";
		$data['prayer_requests_anwered'] = $this->db->query($sql)->result_array();

		// The left join gets the optional leader name 
		$sql = "select a.id, a.event_type, a.compid, a.details, a.leader, a.date, a.date_sort, a.title, a.event_tip, a.address, a.contact_1, a.contact_2, a.duration_note, 
		a.transport_1, a.transport_2, a.image_url, b.first_name as leader_first_name, b.last_name as leader_last_name 
		from teampro_events a 
		left join ainf_vps3_users b on a.leader = b.userid 
		where a.compid = $varcompid order by date_sort desc"; 
		$data['events_list'] = $this->db->query($sql)->result_array();

		// //// // // // // // // // // echo   "";
		// $pagename_orig = "visitors-list.php";
		// $pagename_orig = "visitors-list";
		
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

}
	
